#include <iostream>

#include "dyn.hh"

#define debug(var) do{ \
    cout << #var << " = " << (var).value() << " ("; \
    (var).debug(); \
    cout << ")\n"; }while(0) \

int main(void)
{
    dyn<int> a,b,c,d;
    
    a = 1;
    b = 2;
    
    c = a+b;
    
    debug(a);
    debug(b);
    debug(c);
    
    a = 3;
    
    debug(c);
    cout << "Listn 4 * b\n";
    
    for(int i=0; i<4; ++i)
        c += b;
        
    debug(c);
    
    b = 3;

    debug(b);
    debug(c);
    
    a = b;
    b = a;
    
    debug(b);
    
    return 0;
}
